BeamAndGo.Member.Admin.Web/Pages/Member/AddressManagement.cshtml.cs
using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using BeamAndGo.Member.Admin.Web.Models.FormData;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Admin.Web.Pages.Member
{
    [LoginRequired]
    public class AddressManagementModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<AddressManagementModel> _logger;
        private readonly IMemberAddressService _memberAddressService;
        private readonly IMemberService _memberService;


        public bool KYCEnabled { get; set; }
        public bool IsXHR { get { return Request.Headers["X-Requested-With"] == "XMLHttpRequest"; } }
        public IAsyncEnumerable<MemberAddress> MemberAddresses { get; set; }
        public BeamAndGo.Member.Member Member { get; set; }
        public string MemberCountryCode { get; set; }


        [BindProperty]
        public AddressFormData AddressFormData { get; set; }
        [BindProperty]
        public string MemberAddressSid { get; set; }
        [BindProperty]
        public string SelectedMemberSid { get; set; }
        
     
        public AddressManagementModel(ILogger<AddressManagementModel> logger, 
                                      IMemberService memberService, 
                                      IMemberAddressService memberAddressService,  
                                      IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _memberService = memberService;
            _memberAddressService = memberAddressService;
            _applicationOptions = applicationOptions.Value;
       }

        public async Task<IActionResult> OnGetAsync(string memberSid)
        {
            try
            {
                KYCEnabled = _applicationOptions.KYCEnabled;
                Member = (await _memberService.GetBySid(memberSid));
                MemberCountryCode = Member?.CountryCode;

                MemberAddresses = _memberAddressService.ListByMemberSid(Member.Sid);
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostResendAddressAsync()
        {
            try
            {
                //Temporary not in use
                await _memberAddressService.Verify(MemberAddressSid, string.Empty);

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully resend a verification to your email");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to resend address {@MemberAddressSid}", MemberAddressSid);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect($"~/Member/Edit?memberSid={SelectedMemberSid}");
        }

        public async Task<IActionResult> OnPostMakePrimaryAddressAsync(string addressSid)
        {
            try
            {
                await _memberAddressService.SetDefault(addressSid);
                return new OkObjectResult("Successfully updated your primary address");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to make primary {@addressSid}", addressSid);
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }

        public async Task<IActionResult> OnPostRemoveAddressAsync()
        {
            try
            {
                await _memberAddressService.Delete(MemberAddressSid);
                return new OkObjectResult("Successfully removed your address");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to remove address {@MemberAddressSid}", MemberAddressSid);
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }

        public async Task<IActionResult> OnPostAddAddressAsync()
        {
            try
            {
                if (ModelState.IsValid)
                {
                    var sid = SelectedMemberSid;
                    await _memberAddressService.Create(
                        sid,
                        AddressFormData.Name,
                        AddressFormData.Street,
                        AddressFormData.PostalCode,
                        AddressFormData.Country
                    );
                    return new OkObjectResult("Successfully added your address");
                }
                else
                {
                    return BadRequest("Please enter a valid address");
                }
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, "Failed to add address");
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/Member/CreateMember.cshtml.cs
using System;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member.Signup;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using System.Linq;

namespace BeamAndGo.Member.Admin.Web.Pages
{
    [LoginRequired]
    [ValidateAntiForgeryToken]
    public class CreateMemberModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<CreateMemberModel> _logger;
        private readonly IMemberSignupService _memberSignupService;


        public string MaxBirthdate { get; set; }
        public string MinBirthdate { get; set; }
        public string StaticAssetsUrl { get; set; }


        [BindProperty]
        public SignupData FormData { get; set; }
        [BindProperty]
        public string Birthdate { get; set; }


        public CreateMemberModel(ILogger<CreateMemberModel> logger,
                                 IMemberSignupService memberSignupService,
                                 IOptions<ApplicationOptions> applicationOptions)
        {
            _applicationOptions = applicationOptions.Value;
            _logger = logger;
            _memberSignupService = memberSignupService;
            FormData = new SignupData();
        }

        public IActionResult OnGet()
        {
            try
            {
                MinBirthdate = DateTime.Now.AddYears(-100).ToString("yyyy-MM-dd");
                MaxBirthdate = DateTime.Now.AddYears(-1).ToString("yyyy-MM-dd");
                StaticAssetsUrl = _applicationOptions.StaticAssetsUrl;
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostCreateAsync()
        {
            if (ModelState.IsValid)
            {
                try
                {
                    var birthDate = Convert.ToDateTime(Birthdate);

                    if (birthDate.Year > 1)
                    {
                        FormData.BirthDay = birthDate.Day;
                        FormData.BirthMonth = birthDate.Month;
                        FormData.BirthYear = birthDate.Year;
                    }

                    var createdMember = await _memberSignupService.Signup(FormData);

                    return new OkObjectResult("Successfully created new member");
                }
                catch (ArgumentException ex)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
                }
                catch (Exception ex)
                {
                    if (ex is InvalidOperationException)
                    {
                        _logger.LogInformation(ex, ex.Message);
                        return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                    }
                    else
                    {
                        _logger.LogError(ex, ex.Message);
                        return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                    }
                }
            }
            else
            {
                var message = string.Join("\n", ModelState.Values
                                    .SelectMany(v => v.Errors)
                                    .Select(e => e.ErrorMessage));

                return BadRequest(message);
            }
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/Member/Preference.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Member;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace BeamAndGo.Member.Admin.Web.Pages.Member
{
    [LoginRequired]
    public class PreferenceModel : PageModel
    {
        private readonly ILogger<PreferenceModel> _logger;
        private readonly IMemberPreferenceService _memberPreferenceService;
        private readonly IMemberPreferenceTypeService _memberPreferenceTypeService;


        public bool IsXHR { get { return Request.Headers["X-Requested-With"] == "XMLHttpRequest"; } }
        public IAsyncEnumerable<MemberPreference> MemberPreferences { get; set; }


        [BindProperty]
        public string CurrentSelectedValue { get; set; }
        [BindProperty]
        public string SelectedMemberSid { get; set; }
        [BindProperty]
        public string SelectedPreferenceTypeId { get; set; }


        public PreferenceModel(ILogger<PreferenceModel> logger,
                                            IMemberPreferenceService memberPreferenceService,
                                            IMemberPreferenceTypeService memberPreferenceTypeService)
        {
            _logger = logger;
            _memberPreferenceService = memberPreferenceService;
            _memberPreferenceTypeService = memberPreferenceTypeService;
        }

        public IActionResult OnGet(string memberSid)
        {
            var sid = memberSid;

            try
            {
                SelectedMemberSid = sid;
                MemberPreferences = _memberPreferenceService.ListWithDefaultByMemberSid(memberSid);
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostUpdatePreferenceAsync()
        {
            var sid = SelectedMemberSid;

            try
            {
                if (CurrentSelectedValue.ToLower() == "true")
                {
                    await _memberPreferenceService.CreateOrUpdate(sid, Convert.ToInt32(SelectedPreferenceTypeId), "true");
                }
                else
                {
                    await _memberPreferenceService.CreateOrUpdate(sid, Convert.ToInt32(SelectedPreferenceTypeId), "false");
                }

                return new OkObjectResult("Successfully updated Preference");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                return BadRequest($"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return BadRequest($"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, $"Failed to update Communication Preference");
                    return BadRequest(ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/Member/AddressManagement.cshtml
@page
@model BeamAndGo.Member.Admin.Web.Pages.Member.AddressManagementModel
@{
    ViewData["Title"] = "Address Management";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";
}

<style>
    .country-select {
        width: 100% !important;
    }
</style>

<div class="@(!Model.IsXHR ? "uk-container" : "")">
    <div class="uk-margin-small">
        <h3>Address Management</h3>
        <div class="uk-margin">
            @await foreach (var address in Model.MemberAddresses)
            {
                <div class="uk-margin-small @(address.IsDefault? "uk-text-bold" : "")">
                    <div class="uk-card uk-card-default uk-card-small uk-card-body uk-width-1-1">
                        <div uk-grid>
                            <div class=" uk-width-expand@s">
                                <p class="uk-form-label uk-margin-remove">@address.Name</p>
                                <p class="uk-form-label uk-margin-remove">@address.Street</p>
                                <p class="uk-form-label uk-margin-remove">@address.CountryCode @address.PostalCode</p>
                            </div>
                            <div class="uk-width-auto@s uk-margin-remove">
                                <p class="uk-margin-remove uk-text-left@s uk-text-right@m">
                                    @if (address.IsDefault)
                                    {
                                        <span class="uk-badge uk-label uk-label-success">Primary</span>
                                    }
                                    @if (Model.KYCEnabled)
                                    {
                                        @if (address.IsVerified)
                                        {
                                            <span class="uk-badge uk-label uk-label-success">Verified</span>
                                        }
                                        else
                                        {
                                            <span class="uk-badge uk-label uk-label-warning">Unverified</span>
                                        }
                                    }
                                </p>
                            </div>
                        </div>
                        <div class="uk-margin-medium-top uk-align-right uk-flex-inline">
                            @if (!address.IsDefault)
                            {
                                @if (!address.IsVerified)
                                {
                                    <form asp-page-handler="MakePrimaryAddress"
                                          method="post"
                                          asp-antiforgery="true"
                                          asp-route-addressSid="@address.Sid"
                                          asp-route-memberSid="@Model.Member.Sid"
                                          data-ajax="true"
                                          data-ajax-method="post"
                                          data-ajax-success="makePrimaryAddressSuccess"
                                          data-ajax-failure="makePrimaryAddressFailed">
                                        <button class="member-address-make-primary uk-button uk-button-small uk-text-nowrap"
                                                style="padding:5px 10px;"
                                                type="submit"
                                                memberAddressSid="@address.Sid">
                                            <i class="fas fa-star uk-margin-small-right"></i>Make Primary
                                        </button>
                                    </form>
                                }

                                <div class="uk-margin-small-left">
                                    <button class="member-address-remove uk-button uk-button-small"
                                            style="padding:5px 10px;"
                                            uk-toggle="target: #modal-address-remove"
                                            memberAddressSid="@address.Sid"
                                            memberAddress="@address.Name <br /> @address.Street <br /> @address.CountryCode @address.PostalCode <br />">
                                        <i class="fas fa-trash"></i>
                                    </button>
                                </div>
                            }
                        </div>
                    </div>
                </div>
            }
        </div>
        <div class="uk-align-right">
            <a class="uk-button uk-button-primary" uk-toggle="target: #modal-address-add">Add New Address</a>
        </div>
    </div>
</div>
<!-- This is the modal for ResendAddress -->
<div id="modal-address-resend-verification" uk-modal>
    <div class="uk-modal-dialog uk-modal-body uk-text-center">
        <p>A verification email has been sent to your e-mail address. Please follow the instructions in your email to verify your e-mail address</p>
        <form class="uk-margin" method="post" asp-page-handler="ResendAddress" asp-antiforgery="true">
            <input asp-for="@Model.MemberAddressSid" class="member-address-resend-verification-input" type="hidden">
            <input type="hidden" asp-for="SelectedMemberSid" value="@Model.Member.Sid">
            <button class="uk-button uk-button-primary" type="submit">Ok</button>
        </form>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal for RemoveAddress -->
<div id="modal-address-remove" uk-modal>
    <div class="uk-modal-dialog uk-modal-body uk-text-center">
        <p class="uk-margin-remove"> Are you sure you want to remove this Address? </p>
        <p class="uk-margin-remove modal-address"></p>
        <form class="uk-margin" method="post" asp-page-handler="RemoveAddress" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="removeAddressSuccess" data-ajax-failure="removeAddressFailed">
            <input asp-for="@Model.MemberAddressSid" class="member-address-remove-input" type="hidden">
            <input type="hidden" asp-for="SelectedMemberSid" value="@Model.Member.Sid">
            <button class="uk-button uk-button-primary" type="submit">Yes</button>
            @if (Model.IsXHR)
            {
                <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>No</a>
            }
            else
            {
                <button class="uk-button uk-button-default uk-modal-close" type="button">No</button>
            }
        </form>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal for AddAddress -->
<div id="modal-address-add" uk-modal>
    <div class="uk-modal-dialog uk-modal-body">
        <h2 class="uk-modal-title">Add address</h2>
        <form class="uk-margin" method="post" asp-page-handler="AddAddress" asp-antiforgery="true" data-ajax="true" data-ajax-method="post" data-ajax-success="addAddressSuccess" data-ajax-failure="addAddressFailed">
            <input type="hidden" asp-for="SelectedMemberSid" value="@Model.Member.Sid">
            <div class="uk-margin-small">
                <div>
                    <label asp-for="AddressFormData.Name" class="uk-form-label"></label>
                    <input asp-for="AddressFormData.Name" class="uk-input" type="text" maxlength="128" required>
                    <span asp-validation-for="AddressFormData.Name" class="uk-text-danger uk-text-small"></span>
                </div>
                <div>
                    <label asp-for="AddressFormData.Street" class="uk-form-label"></label>
                    <textarea asp-for="AddressFormData.Street" class="uk-textarea" rows="3" type="text" maxlength="128"></textarea>
                    <span asp-validation-for="AddressFormData.Street" class="uk-text-danger uk-text-small"></span>
                </div>
                <div class=" uk-grid-small" uk-grid>
                    <div class="uk-width-1-2@m">
                        <label asp-for="AddressFormData.PostalCode" class="uk-form-label"></label>
                        <input asp-for="AddressFormData.PostalCode" class="uk-input" type="text" maxlength="128" required>
                        <span asp-validation-for="AddressFormData.PostalCode" class="uk-text-danger uk-text-small"></span>
                    </div>
                    <div class="uk-width-1-2@m">
                        <label asp-for="AddressFormData.Country" class="uk-form-label"></label>
                        <input id="address-country-code" class="uk-input" type="text" readonly="readonly">
                        <input type="hidden" id="new-address-country-code" asp-for="AddressFormData.Country">
                        <span asp-validation-for="AddressFormData.Country" class="uk-text-danger uk-text-small"></span>
                    </div>
                </div>
            </div>
            <p class="uk-text-right">
                <button class="uk-button uk-button-primary" type="submit">Add Address</button>
                @if (Model.IsXHR)
                {
                    <a class="uk-button uk-button-default" href="#bng-modal" uk-toggle>Cancel</a>
                }
                else
                {
                    <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                }
            </p>
        </form>
    </div>
</div>
<!-- End of modal -->
<script>
     //Country
    $(document).ready(function () {
        selectedAddressCountry();
    });

     $("#address-country-code").countrySelect({
        defaultCountry: '@Model.MemberCountryCode.ToLower()',
        preferredCountries: ["au", "ca", "hk", "jp", "my", "ph", "qa", "sa", "sg", "tw", "ae", "us", "gb"],
    });

    function selectedAddressCountry() {
        var country_code = $("#address-country-code").countrySelect("getSelectedCountryData");
        $("#new-address-country-code").val(country_code.iso2.toUpperCase());
    }

    $("#address-country-code").change(function () {
        selectedAddressCountry();
    });

    //
    $('.member-address-resend-verification').click(function () {
        $('.member-address-resend-verification-input').val($(this).attr('memberAddressSid'));
    });
    $('.member-address-remove').click(function () {
        $('.member-address-remove-input').val($(this).attr('memberAddressSid'));
        $('.modal-address').html($(this).attr('memberAddress'));
    });

    // Add Address
    addAddressSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    addAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Remove Address
    removeAddressSuccess = (xhr) => {
        $("#modal-address-remove").remove();
        UIkit.modal("#bng-modal").hide();
        showSuccessNotification(xhr);
    };
    removeAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };

    // Make Primary Address
    makePrimaryAddressSuccess = (xhr) => {
        location.reload();
        showSuccessNotification(xhr);
    };
    makePrimaryAddressFailed = (xhr) => {
        UIkit.modal("#bng-modal").show();
        showErrorNotification(xhr.responseText);
    };
</script>

BeamAndGo.Member.Admin.Web/Pages/Member/Preference.cshtml
@page
@model BeamAndGo.Member.Admin.Web.Pages.Member.PreferenceModel
@{
    ViewData["Title"] = "Preferences";
    if (Model.IsXHR) Layout = null;
    else Layout = "_Layout";
}

<style>
    .uk-switch {
        position: relative;
        display: inline-block;
        height: 34px;
        width: 60px;
    }
        /*Hide default HTML checkbox*/
        .uk-switch input {
            display: none;
        }
    /* Slider */
    .uk-switch-slider {
        background-color: rgba(0,0,0,0.22);
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        border-radius: 500px;
        bottom: 0;
        cursor: pointer;
        transition-property: background-color;
        transition-duration: .2s;
        box-shadow: inset 0 0 2px rgba(0,0,0,0.07);
    }
        /* Switch pointer */
        .uk-switch-slider:before {
            content: '';
            background-color: #fff;
            position: absolute;
            width: 30px;
            height: 30px;
            left: 2px;
            bottom: 2px;
            border-radius: 50%;
            transition-property: transform, box-shadow;
            transition-duration: .2s;
        }
    /* Slider active color */
    input:checked + .uk-switch-slider {
        background-color: #39f !important;
    }
        /* Pointer active animation */
        input:checked + .uk-switch-slider:before {
            transform: translateX(26px);
        }
</style>

<div class="@(!Model.IsXHR ? "uk-container" : "")">
    <div class="@(!Model.IsXHR ? "uk-flex-center uk-grid" : "")">
        <div class="@(!Model.IsXHR ? "uk-width-2-3@s" : "")">

            <form class="uk-form-stacked" id="form-preference" asp-antiforgery="true" method="post"  asp-page-handler="UpdatePreference" data-ajax="true" data-ajax-method="post" data-ajax-success="updatePreferenceSuccess" data-ajax-failure="updatePreferenceFailed" novalidate>
                <div class="@(!Model.IsXHR ? "uk-card uk-card-default uk-card-small uk-card-body" : "") uk-width-1-1@m">
                    <h3>Preferences</h3>
                    <input type="hidden" asp-for="SelectedMemberSid" value="@Model.SelectedMemberSid">
                    @await foreach (var memberPreference in Model.MemberPreferences)
                    {
                        <div class="uk-margin-small uk-grid-small" uk-grid>
                            <input type="hidden" id="PreferenceTypeId" asp-for="SelectedPreferenceTypeId" />
                            <input type="hidden" id="MemberPreferenceValue" asp-for="CurrentSelectedValue" />

                            <div class="uk-width-auto">
                                <input type="checkbox" id="@memberPreference.PreferenceTypeId" class="uk-checkbox preference-checked" @(memberPreference.Value.ToLower() == "true" ? "checked" : "")
                                       SelectedPreferenceTypeId="@memberPreference.PreferenceTypeId">
                            </div>
                            <div class="uk-width-expand">
                                <label class="uk-text-bold"> @memberPreference.PreferenceType.Name</label>
                                <p class="uk-margin-remove">@memberPreference.PreferenceType.Description</p>
                            </div>
                        </div>
                    }
                </div>
            </form>
        </div>
    </div>
</div>

<script>
    $('.preference-checked').click(function () {
        $('#PreferenceTypeId').val($(this).attr('SelectedPreferenceTypeId'));

        if ($('#' + $(this).attr('SelectedPreferenceTypeId')).is(':checked')) {
            $('#MemberPreferenceValue').val("true");
        } else {
            $('#MemberPreferenceValue').val("false");
        }

        $("#form-preference").submit();
    });

    updatePreferenceSuccess = (xhr) => {
        showSuccessNotification(xhr);
    };
    updatePreferenceFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };
</script>